'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var styledComponents = require('styled-components');

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(source, true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(source).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _taggedTemplateLiteral(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
}

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */
var cosmicTheme = {
  radius: '0.5rem',
  colorBg: '#3d3780',
  colorBgActive: '#494299',
  colorFg: '#a1a1e5',
  colorFgHeading: '#ffffff',
  colorFgText: '#d1d1ff',
  colorFgHighlight: '#00f9a6',
  colorPrimary: '#7659ff',
  colorSuccess: '#00d977',
  colorInfo: '#0088ff',
  linkColor: '#00f9a6',
  linkColorHover: '#14ffbe',
  separator: '#342e73',
  shadow: '0 8px 20px 0 rgba(40, 37, 89, 0.6)',
  cardHeaderFontWeight: 'fontWeightBolder',
  layoutBg: '#2f296b',
  scrollbarFg: '#554db3',
  scrollbarBg: '#332e73',
  radialGradient: 'radialGradient(circle at 50% 50%, #423f8c, #302c6e)',
  linearGradient: 'linear-gradient(to right, #171749, #413789)',
  sidebarWidth: '16.25rem',
  sidebarWidthCompact: '3.45rem',
  headerFg: 'colorWhite',
  footerFg: 'colorFg',
  footerHeight: 'headerHeight',
  userFg: 'colorBg',
  userBg: 'colorFg',
  userFgHighlight: 'colorFgHighlight',
  popoverBorder: 'colorPrimary',
  popoverShadow: 'shadow',
  contextMenuActiveBg: 'colorPrimary',
  contextMenuBorder: 'colorPrimary',
  menuFg: 'colorFg',
  menuBg: 'colorBg',
  menuActiveFg: 'colorWhite',
  menuGroupFg: 'colorWhite',
  menuFontWeight: 'fontWeightNormal',
  menuActiveFontWeight: 'fontWeightBolder',
  menuSubmenuBg: 'layoutBg',
  menuSubmenuFg: 'colorFg',
  menuSubmenuActiveFg: 'colorFgHeading',
  menuSubmenuActiveBg: 'rgba(0, 255, 170, 0.25)',
  menuSubmenuActiveBorderColor: 'colorFgHighlight',
  menuSubmenuActiveShadow: '0 2px 12px 0 rgba(0, 255, 170, 0.25)',
  menuItemPadding: '0.25rem 0.75rem',
  menuItemSeparator: 'transparent',
  btnHeroShadow: '0 4px 10px 0 rgba(33, 7, 77, 0.5)',
  btnHeroTextShadow: '0 1px 3px rgba(0, 0, 0, 0.3)',
  btnHeroBevelSize: '0 3px 0 0',
  btnHeroGlowSize: '0 2px 8px 0',
  btnSecondaryBorder: 'colorPrimary',
  btnOutlineFg: 'colorFgHeading',
  btnOutlineHoverFg: 'colorFgHeading',
  btnOutlineFocusFg: 'colorFgHeading',
  btnGroupBg: '#373273',
  btnGroupSeparator: '#312c66',
  formControlBg: '#37317a',
  formControlFocusBg: 'separator',
  formControlBorderColor: 'separator',
  formControlSelectedBorderColor: 'colorPrimary',
  checkboxBorderColor: 'colorFg',
  searchBg: 'linear-gradient(to right, #171749, #413789)',
  smartTableHeaderFontWeight: 'fontWeightNormal',
  smartTableHeaderBg: 'colorBgActive',
  smartTableBgEven: '#3a347a',
  smartTableBgActive: 'colorBgActive',
  smartTablePagingBorderColor: 'colorPrimary',
  smartTablePagingBorderWidth: '2px',
  smartTablePagingFgActive: 'colorFgHeading',
  smartTablePagingBgActive: 'colorPrimary',
  smartTablePagingHover: 'rgba(0, 0, 0, 0.2)',
  spinnerBg: 'rgba(61, 55, 128, 0.9)',
  stepperAccentColor: 'colorSuccess',
  calendarActiveItemBg: 'colorPrimary',
  calendarSelectedItemBg: 'colorPrimary',
  calendarRangeBgInRange: '#4e4095',
  calendarTodayItemBg: '#352f6e',
  selectOptionDisabledBg: '#312e75',
  toastrColorFg: 'colorWhite',
  toastrPadding: '1.25rem',
  toastrBorder: 0,
  toastrDefaultBackground: '#bcc3cc',
  tooltipFg: 'colorBg',
  tooltipStatusFg: 'colorWhite',
  datepickerBorder: 'colorPrimary',
  datepickerShadow: 'shadow',
  radioCheckedBorderColor: 'colorPrimary',
  radioCheckedCheckmark: 'colorPrimary'
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */
var corporateTheme = {
  headerFg: '#f7fafb',
  headerBg: '#111218',
  layoutBg: '#f1f5f8',
  colorFgHeading: '#181818',
  colorFgText: '#4b4b4b',
  colorFgHighlight: 'colorFg',
  separator: '#cdd5dc',
  radius: '0.17rem',
  scrollbarBg: '#e3e9ee',
  colorPrimary: '#73a1ff',
  colorSuccess: '#5dcfe3',
  colorInfo: '#ba7fec',
  colorWarning: '#ffa36b',
  colorDanger: '#ff6b83',
  btnSecondaryBg: '#edf2f5',
  btnSecondaryBorder: '#edf2f5',
  actionsFg: '#d3dbe5',
  actionsBg: 'colorBg',
  sidebarBg: '#e3e9ee',
  borderColor: '#d5dbe0',
  menuFontWeight: 'fontWeightBolder',
  menuFg: 'colorFgText',
  menuBg: '#e3e9ee',
  menuActiveFg: 'colorFgHeading',
  menuActiveBg: 'menuBg',
  menuSubmenuBg: 'menuBg',
  menuSubmenuFg: 'colorFgText',
  menuSubmenuActiveFg: 'colorFgHeading',
  menuSubmenuActiveBg: '#cdd5dc',
  menuSubmenuActiveBorderColor: 'menuSubmenuActiveBg',
  menuSubmenuActiveShadow: 'none',
  menuSubmenuHoverFg: 'menuSubmenuActiveFg',
  menuSubmenuHoverBg: 'menuBg',
  menuSubmenuItemBorderWidth: '0.125rem',
  menuSubmenuItemBorderRadius: 'radius',
  menuSubmenuItemPadding: '0.5rem 1rem',
  menuSubmenuItemContainerPadding: '0 1.25rem',
  menuSubmenuPadding: '0.5rem',
  btnBorderRadius: 'btnSemiRoundBorderRadius',
  btnHeroDegree: '0deg',
  btnHeroGlowSize: '0 0 20px 0',
  btnHeroSecondaryGlowSize: '0 0 0 0',
  btnHeroBorderRadius: 'btnBorderRadius',
  cardShadow: 'none',
  cardBorderWidth: '1px',
  cardBorderColor: 'borderColor',
  cardHeaderBorderWidth: 0,
  linkColor: '#5dcfe3',
  linkColorHover: '#7dcfe3',
  linkColorVisited: 'linkColor',
  actionsSeparator: '#f1f4f5',
  modalSeparator: 'borderColor',
  tabsSelected: 'colorPrimary',
  tabsSelectedSecondColor: 'colorSuccess',
  smartTablePagingBgActive: 'colorPrimary',
  routeTabsSelected: 'colorPrimary',
  popoverBorder: 'colorPrimary',
  footerShadow: 'none',
  footerSeparator: 'borderColor',
  footerFgHighlight: '#2a2a2a',
  calendarTodayItemBg: '#a2b2c7',
  calendarActiveItemBg: 'colorPrimary',
  calendarRangeBgInRange: '#e3ecfe',
  calendarTodayFg: 'colorWhite',
  toastrIconRadius: 'radius',
  datepickerBorder: 'colorPrimary'
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */
var defaultTheme = {
  fontMain: '"Segoe UI", Roboto, "Helvetica Neue", Arial, sans-serif',
  fontSecondary: 'fontMain',
  fontWeightThin: 200,
  fontWeightLight: 300,
  fontWeightNormal: 400,
  fontWeightBolder: 500,
  fontWeightBold: 600,
  fontWeightUltraBold: 800,
  baseFontSize: '16px',
  fontSizeXlg: '1.25rem',
  fontSizeLg: '1.125rem',
  fontSize: '1rem',
  fontSizeSm: '0.875rem',
  fontSizeXs: '0.75rem',
  radius: '0.375rem',
  padding: '1.25rem',
  margin: '1.5rem',
  lineHeight: 1.25,
  colorBg: '#ffffff',
  colorBgActive: '#e9edf2',
  colorFg: '#a4abb3',
  colorFgHeading: '#2a2a2a',
  colorFgText: '#4b4b4b',
  colorFgHighlight: '#40dc7e',
  separator: '#ebeef2',
  colorGray: 'rgba(81, 113, 165, 0.15)',
  colorNeutral: 'transparent',
  colorWhite: '#ffffff',
  colorDisabled: 'rgba(255, 255, 255, 0.4)',
  colorPrimary: '#8a7fff',
  colorSuccess: '#40dc7e',
  colorInfo: '#4ca6ff',
  colorWarning: '#ffa100',
  colorDanger: '#ff4c6a',
  socialColorFacebook: '#3b5998',
  socialColorTwitter: '#55acee',
  socialColorGoogle: '#dd4b39',
  socialColorLinkedin: '#0177b5',
  socialColorGithub: '#6b6b6b',
  socialColorStackoverflow: '#2f96e8',
  socialColorDribble: '#f26798',
  socialColorBehance: '#0093fa',
  borderColor: 'colorGray',
  shadow: '0 2px 12px 0 #dfe3eb',
  linkColor: '#3dcc6d',
  linkColorHover: '#2ee56b',
  linkColorVisited: 'linkColor',
  scrollbarFg: '#dadada',
  scrollbarBg: '#f2f2f2',
  scrollbarWidth: '5px',
  scrollbarThumbRadius: '2.5px',
  radialGradient: 'none',
  linearGradient: 'none',
  cardFontSize: 'fontSize',
  cardLineHeight: 'lineHeight',
  cardFontWeight: 'fontWeightNormal',
  cardFg: 'colorFg',
  cardFgText: 'colorFgText',
  cardFgHeading: 'colorFgHeading',
  cardBg: 'colorBg',
  cardHeightXXS: '96px',
  cardHeightXS: '216px',
  cardHeightSM: '336px',
  cardHeightMD: '456px',
  cardHeightLG: '576px',
  cardHeightXL: '696px',
  cardHeightXXL: '816px',
  cardShadow: 'shadow',
  cardBorderWidth: 0,
  cardBorderType: 'solid',
  cardBorderColor: 'colorBg',
  cardBorderRadius: 'radius',
  cardPadding: 'padding',
  cardMargin: 'margin',
  cardHeaderFontFamily: 'fontSecondary',
  cardHeaderFontSize: 'fontSizeLg',
  cardHeaderFontWeight: 'fontWeightBold',
  cardSeparator: 'separator',
  cardHeaderFg: 'colorFg',
  cardHeaderFgHeading: 'colorFgHeading',
  cardHeaderActiveBg: 'colorFg',
  cardHeaderActiveFg: 'colorBg',
  cardHeaderDisabledBg: 'colorDisabled',
  cardHeaderPrimaryBg: 'colorPrimary',
  cardHeaderInfoBg: 'colorInfo',
  cardHeaderSuccessBg: 'colorSuccess',
  cardHeaderWarningBg: 'colorWarning',
  cardHeaderDangerBg: 'colorDanger',
  cardHeaderBorderWidth: '1px',
  cardHeaderBorderType: 'solid',
  cardHeaderBorderColor: 'cardSeparator',
  headerFontFamily: 'fontSecondary',
  headerFontSize: 'fontSize',
  headerLineHeight: 'lineHeight',
  headerFg: 'colorFgHeading',
  headerBg: 'colorBg',
  headerHeight: '4.75rem',
  headerPadding: '1.25rem',
  headerShadow: 'shadow',
  footerHeight: '4.725rem',
  footerPadding: '1.25rem',
  footerFg: 'colorFgHeading',
  footerFgHighlight: 'colorFgHeading',
  footerBg: 'colorBg',
  footerSeparator: 'separator',
  footerShadow: 'shadow',
  layoutFontFamily: 'fontMain',
  layoutFontSize: 'fontSize',
  layoutLineHeight: 'lineHeight',
  layoutFg: 'colorFg',
  layoutBg: '#ebeff5',
  layoutMinHeight: '100vh',
  layoutContentWidth: '900px',
  layoutWindowModeMinWidth: '300px',
  layoutWindowModeMaxWidth: '1920px',
  layoutWindowModeBg: 'layoutBg',
  layoutWindowModePaddingTop: '4.75rem',
  layoutWindowShadow: 'shadow',
  layoutPadding: '2.25rem 2.25rem 0.75rem',
  layoutMediumPadding: '1.5rem 1.5rem 0.5rem',
  layoutSmallPadding: '1rem 1rem 0',
  sidebarFontSize: 'fontSize',
  sidebarLineHeight: 'lineHeight',
  sidebarFg: 'colorFgHeading',
  sidebarBg: 'colorBg',
  sidebarHeight: '100vh',
  sidebarWidth: '16rem',
  sidebarWidthCompact: '3.5rem',
  sidebarPadding: 'padding',
  sidebarHeaderHeight: '3.5rem',
  sidebarFooterHeight: '3.5rem',
  sidebarShadow: 'shadow',
  menuFontFamily: 'fontSecondary',
  menuFontSize: 'fontSize',
  menuFontWeight: 'fontWeightBolder',
  menuFg: 'colorFgText',
  menuBg: 'colorBg',
  menuActiveFg: 'colorFgHeading',
  menuActiveBg: 'colorBg',
  menuActiveFontWeight: 'fontWeightBold',
  menuSubmenuBg: 'colorBg',
  menuSubmenuFg: 'colorFgText',
  menuSubmenuActiveFg: 'colorFgHeading',
  menuSubmenuActiveBg: 'colorBg',
  menuSubmenuActiveBorderColor: 'colorFgHighlight',
  menuSubmenuActiveShadow: 'none',
  menuSubmenuHoverFg: 'menuSubmenuActiveFg',
  menuSubmenuHoverBg: 'menuSubmenuBg',
  menuSubmenuItemBorderWidth: '0.125rem',
  menuSubmenuItemBorderRadius: 'radius',
  menuSubmenuItemPadding: '0.5rem 1rem',
  menuSubmenuItemContainerPadding: '0 1.25rem',
  menuSubmenuPadding: '0.5rem',
  menuGroupFontWeight: 'fontWeightBolder',
  menuGroupFontSize: '0.875rem',
  menuGroupFg: 'colorFg',
  menuGroupPadding: '1rem 1.25rem',
  menuItemPadding: '0.675rem 0.75rem',
  menuItemSeparator: 'separator',
  menuIconFontSize: '1.75rem',
  menuIconMargin: '0 0.75rem 0',
  menuIconColor: 'colorFg',
  menuIconActiveColor: 'colorFgHeading',
  tabsFontFamily: 'fontSecondary',
  tabsFontSize: 'fontSizeLg',
  tabsContentFontFamily: 'fontMain',
  tabsContentFontSize: 'fontSize',
  tabsActiveBg: 'transparent',
  tabsActiveFontWeight: 'cardHeaderFontWeight',
  tabsPadding: 'padding',
  tabsContentPadding: 'padding',
  tabsHeaderBg: 'transparent',
  tabsSeparator: 'separator',
  tabsFg: 'colorFg',
  tabsFgText: 'colorFgText',
  tabsFgHeading: 'colorFgHeading',
  tabsBg: 'transparent',
  tabsSelected: 'colorSuccess',
  tabsSelectedSecondColor: 'linkColor',
  tabsIconOnlyMaxWidth: '576px',
  routeTabsFontFamily: 'fontSecondary',
  routeTabsFontSize: 'fontSizeLg',
  routeTabsActiveBg: 'transparent',
  routeTabsActiveFontWeight: 'cardHeaderFontWeight',
  routeTabsPadding: 'padding',
  routeTabsHeaderBg: 'transparent',
  routeTabsSeparator: 'separator',
  routeTabsFg: 'colorFg',
  routeTabsFgHeading: 'colorFgHeading',
  routeTabsBg: 'transparent',
  routeTabsSelected: 'colorSuccess',
  routeTabsIconOnlyMaxWidth: '576px',
  userFontSize: 'fontSize',
  userLineHeight: 'lineHeight',
  userBg: 'colorBg',
  userFg: 'colorFg',
  userFgHighlight: '#bcc3cc',
  userFontFamilySecondary: 'fontSecondary',
  userSizeSM: '1.5rem',
  userSizeMD: '2.5rem',
  userSizeLG: '3.25rem',
  userSizeXL: '4rem',
  popoverFg: 'colorFgHeading',
  popoverBg: 'colorBg',
  popoverBorder: 'colorSuccess',
  popoverBorderRadius: 'radius',
  popoverShadow: 'none',
  popoverArrowSize: 11,
  contextMenuFg: 'colorFgHeading',
  contextMenuBg: 'colorBg',
  contextMenuActiveFg: 'colorWhite',
  contextMenuActiveBg: 'colorSuccess',
  contextMenuBorder: 'colorSuccess',
  contextMenuBorderRadius: 'radius',
  contextMenuShadow: 'none',
  contextMenuArrowSize: 11,
  actionsFontSize: 'fontSize',
  actionsFontFamily: 'fontSecondary',
  actionsLineHeight: 'lineHeight',
  actionsFg: 'colorFg',
  actionsBg: 'colorBg',
  actionsSeparator: 'separator',
  actionsPadding: 'padding',
  actionsSizeSM: '1.5rem',
  actionsSizeMD: '2.25rem',
  actionsSizeLG: '3.5rem',
  searchBtnOpenFg: 'colorFg',
  searchBtnCloseFg: 'colorFg',
  searchBg: 'layoutBg',
  searchBgSecondary: 'colorFg',
  searchText: 'colorFgHeading',
  searchInfo: 'colorFg',
  searchDash: 'colorFg',
  searchPlaceholder: 'colorFg',
  smartTableHeaderFontFamily: 'fontSecondary',
  smartTableHeaderFontSize: 'fontSize',
  smartTableHeaderFontWeight: 'fontWeightBold',
  smartTableHeaderLineHeight: 'lineHeight',
  smartTableHeaderFg: 'colorFgHeading',
  smartTableHeaderBg: 'colorBg',
  smartTableFontFamily: 'fontMain',
  smartTableFontSize: 'fontSize',
  smartTableFontWeight: 'fontWeightNormal',
  smartTableLineHeight: 'lineHeight',
  smartTableFg: 'colorFgHeading',
  smartTableBg: 'colorBg',
  smartTableBgEven: '#f5f7fc',
  smartTableFgSecondary: 'colorFg',
  smartTableBgActive: '#e6f3ff',
  smartTablePadding: '0.875rem 1.25rem',
  smartTableFilterPadding: '0.375rem 0.5rem',
  smartTableSeparator: 'separator',
  smartTableBorderRadius: 'radius',
  smartTablePagingBorderColor: 'separator',
  smartTablePagingBorderWidth: '1px',
  smartTablePagingFgActive: '#ffffff',
  smartTablePagingBgActive: 'colorSuccess',
  smartTablePagingHover: 'rgba(0, 0, 0, 0.05)',
  toastrBg: 'colorBg',
  toastrPadding: '1.125rem',
  toastrFg: 'colorFgText',
  toastrBorder: '0.125rem solid',
  toastrBorderRadius: 'radius',
  toastrBorderColor: '#bcc3cc',
  toastrIconRadius: '0.25rem',
  toastrShadow: 'shadow',
  btnFg: 'colorWhite',
  btnFontFamily: 'fontSecondary',
  btnLineHeight: 'lineHeight',
  btnDisabledOpacity: 0.3,
  btnCursor: 'default',
  btnPrimaryBg: 'colorPrimary',
  btnSecondaryBg: 'transparent',
  btnInfoBg: 'colorInfo',
  btnSuccessBg: 'colorSuccess',
  btnWarningBg: 'colorWarning',
  btnDangerBg: 'colorDanger',
  btnSecondaryBorder: '#dadfe6',
  btnSecondaryBorderWidth: '2px',
  btnPaddingYLG: '0.875rem',
  btnPaddingXLG: '1.75rem',
  btnFontSizeLG: 'fontSizeLg',
  btnPaddingYMD: '0.75rem',
  btnPaddingXMD: '1.5rem',
  btnFontSizeMD: '1rem',
  btnPaddingYSM: '0.625rem',
  btnPaddingXSM: '1.5rem',
  btnFontSizeSM: '0.875rem',
  btnPaddingYXS: '0.5rem',
  btnPaddingXXS: '1.25rem',
  btnFontSizeXS: '0.75rem',
  btnBorderRadius: 'radius',
  btnRectangleBorderRadius: '0.25rem',
  btnSemiRoundBorderRadius: '0.75rem',
  btnRoundBorderRadius: '1.5rem',
  btnHeroShadow: 'none',
  btnHeroTextShadow: 'none',
  btnHeroBevelSize: '0 0 0 0',
  btnHeroGlowSize: '0 0 0 0',
  btnHeroPrimaryGlowSize: 'btnHeroGlowSize',
  btnHeroSuccessGlowSize: 'btnHeroGlowSize',
  btnHeroWarningGlowSize: 'btnHeroGlowSize',
  btnHeroInfoGlowSize: 'btnHeroGlowSize',
  btnHeroDangerGlowSize: 'btnHeroGlowSize',
  btnHeroSecondaryGlowSize: 'btnHeroGlowSize',
  btnHeroDegree: '20deg',
  btnHeroPrimaryDegree: 'btnHeroDegree',
  btnHeroSuccessDegree: 'btnHeroDegree',
  btnHeroWarningDegree: '10deg',
  btnHeroInfoDegree: '10deg',
  btnHeroDangerDegree: '20deg',
  btnHeroSecondaryDegree: 'btnHeroDegree',
  btnHeroBorderRadius: 'radius',
  btnOutlineFg: 'colorFgHeading',
  btnOutlineHoverFg: '#ffffff',
  btnOutlineFocusFg: 'colorFgHeading',
  btnGroupBg: 'layoutBg',
  btnGroupFg: 'colorFgHeading',
  btnGroupSeparator: '#dadfe6',
  formControlTextPrimaryColor: 'colorFgHeading',
  formControlBg: 'colorBg',
  formControlFocusBg: 'colorBg',
  formControlBorderWidth: '2px',
  formControlBorderType: 'solid',
  formControlBorderColor: '#dadfe6',
  formControlRectangleBorderRadius: 'radius',
  formControlSemiRoundBorderRadius: '0.75rem',
  formControlRoundBorderRadius: '1.5rem',
  formControlSelectedBorderColor: 'colorSuccess',
  formControlInfoBorderColor: 'colorInfo',
  formControlSuccessBorderColor: 'colorSuccess',
  formControlDangerBorderColor: 'colorDanger',
  formControlWarningBorderColor: 'colorWarning',
  formControlPlaceholderColor: 'colorFg',
  formControlPlaceholderFontSize: '1rem',
  formControlFontSizeMD: '1rem',
  formControlPaddingMD: '0.75rem 1.125rem',
  formControlFontSizeSM: 'fontSizeSm',
  formControlPaddingSM: '0.375rem 1.125rem',
  formControlFontSizeLG: 'fontSizeLg',
  formControlPaddingLG: '1.125rem 1.125rem',
  formControlLabelFontWeight: 400,
  formControlFeedbackFontSize: '0.875rem',
  formControlFeedbackFontWeight: 'fontWeightNormal',
  checkboxBg: 'transparent',
  checkboxSize: '1.25rem',
  checkboxBorderSize: '2px',
  checkboxBorderColor: 'formControlBorderColor',
  checkboxCheckmark: 'transparent',
  checkboxCheckedBg: 'transparent',
  checkboxCheckedSize: '1.25rem',
  checkboxCheckedBorderSize: '2px',
  checkboxCheckedBorderColor: 'colorSuccess',
  checkboxCheckedCheckmark: 'colorFgHeading',
  checkboxDisabledBg: 'transparent',
  checkboxDisabledSize: '1.25rem',
  checkboxDisabledBorderSize: '2px',
  checkboxDisabledBorderColor: 'colorFgHeading',
  checkboxDisabledCheckmark: 'colorFgHeading',
  modalFontSize: 'fontSize',
  modalLineHeight: 'lineHeight',
  modalFontWeight: 'fontWeightNormal',
  modalFg: 'colorFgText',
  modalFgHeading: 'colorFgHeading',
  modalBg: 'colorBg',
  modalBorder: 'transparent',
  modalBorderRadius: 'radius',
  modalPadding: 'padding',
  modalHeaderFontFamily: 'fontSecondary',
  modalHeaderFontWeight: 'fontWeightBolder',
  modalHeaderFontSize: 'fontSizeLg',
  modalBodyFontFamily: 'fontMain',
  modalBodyFontWeight: 'fontWeightNormal',
  modalBodyFontSize: 'fontSize',
  modalSeparator: 'separator',
  badgeFgText: 'colorWhite',
  badgePrimaryBgColor: 'colorPrimary',
  badgeSuccessBgColor: 'colorSuccess',
  badgeInfoBgColor: 'colorInfo',
  badgeWarningBgColor: 'colorWarning',
  badgeDangerBgColor: 'colorDanger',
  progressBarHeightXL: '1.75rem',
  progressBarHeightLG: '1.5rem',
  progressBarHeightMD: '1.375rem',
  progressBarHeightSM: '1.25rem',
  progressBarHeightXS: '1rem',
  progressBarAnimationDuration: '400ms',
  progressBarFontSizeXL: 'fontSizeXlg',
  progressBarFontSizeLG: 'fontSizeLg',
  progressBarFontSizeMD: 'fontSize',
  progressBarFontSizeSM: 'fontSizeSm',
  progressBarFontSizeXS: 'fontSizeXs',
  progressBarRadius: 'radius',
  progressBarBg: 'layoutBg',
  progressBarFontColor: 'colorWhite',
  progressBarFontWeight: 'fontWeightBold',
  progressBarDefaultBg: 'colorInfo',
  progressBarPrimaryBg: 'colorPrimary',
  progressBarSuccessBg: 'colorSuccess',
  progressBarInfoBg: 'colorInfo',
  progressBarWarningBg: 'colorWarning',
  progressBarDangerBg: 'colorDanger',
  alertFontSize: 'fontSize',
  alertLineHeight: 'lineHeight',
  alertFontWeight: 'fontWeightNormal',
  alertFg: 'colorWhite',
  alertOutlineFg: 'colorFg',
  alertBg: 'colorBg',
  alertActiveBg: 'colorFg',
  alertDisabledBg: 'colorDisabled',
  alertDisabledFg: 'colorFg',
  alertPrimaryBg: 'colorPrimary',
  alertInfoBg: 'colorInfo',
  alertSuccessBg: 'colorSuccess',
  alertWarningBg: 'colorWarning',
  alertDangerBg: 'colorDanger',
  alertHeightXXS: '52px',
  alertHeightXS: '72px',
  alertHeightSM: '92px',
  alertHeightMD: '112px',
  alertHeightLG: '132px',
  alertHeightXL: '152px',
  alertHeightXXL: '172px',
  alertShadow: 'none',
  alertBorderRadius: 'radius',
  alertPadding: '1rem 1.125rem',
  alertClosablePadding: '3rem',
  alertButtonPadding: '3rem',
  alertMargin: 'margin',
  chatFontSize: 'fontSize',
  chatFg: 'colorWhite',
  chatBg: 'colorBg',
  chatBorderRadius: 'radius',
  chatFgText: 'colorFgText',
  chatHeightXXS: '96px',
  chatHeightXS: '216px',
  chatHeightSM: '336px',
  chatHeightMD: '456px',
  chatHeightLG: '576px',
  chatHeightXL: '696px',
  chatHeightXXL: '816px',
  chatBorder: 'border',
  chatPadding: 'padding',
  chatShadow: 'shadow',
  chatSeparator: 'separator',
  chatMessageFg: 'colorWhite',
  chatMessageBg: 'linear-gradient(to right, #4ca6ff, #59bfff)',
  chatMessageReplyBg: 'colorBgActive',
  chatMessageReplyFg: 'colorFgText',
  chatMessageAvatarBg: 'colorFg',
  chatMessageSenderFg: 'colorFg',
  chatMessageQuoteFg: 'colorFg',
  chatMessageQuoteBg: 'colorBgActive',
  chatMessageFileFg: 'colorFg',
  chatMessageFileBg: 'transparent',
  chatFormBg: 'transparent',
  chatFormFg: 'colorFgHeading',
  chatFormBorder: 'separator',
  chatFormPlaceholderFg: 'colorFg',
  chatFormActiveBorder: 'colorFg',
  chatActiveBg: 'colorFg',
  chatDisabledBg: 'colorDisabled',
  chatDisabledFg: 'colorFg',
  chatPrimaryBg: 'colorPrimary',
  chatInfoBg: 'colorInfo',
  chatSuccessBg: 'colorSuccess',
  chatWarningBg: 'colorWarning',
  chatDangerBg: 'colorDanger',
  spinnerBg: 'rgba(255, 255, 255, 0.83)',
  spinnerCircleBg: 'colorBgActive',
  spinnerFg: 'colorFgText',
  spinnerActiveBg: 'colorFg',
  spinnerDisabledBg: 'colorDisabled',
  spinnerDisabledFg: 'colorFg',
  spinnerPrimaryBg: 'colorPrimary',
  spinnerInfoBg: 'colorInfo',
  spinnerSuccessBg: 'colorSuccess',
  spinnerWarningBg: 'colorWarning',
  spinnerDangerBg: 'colorDanger',
  spinnerXXS: '1.25rem',
  spinnerXS: '1.5rem',
  spinnerSM: '1.75rem',
  spinnerMD: '2rem',
  spinnerLG: '2.25rem',
  spinnerXL: '2.5rem',
  spinnerXXL: '3rem',
  stepperIndexSize: '2rem',
  stepperLabelFontSize: 'fontSizeSm',
  stepperLabelFontWeight: 'fontWeightBolder',
  stepperAccentColor: 'colorPrimary',
  stepperCompletedFg: 'colorWhite',
  stepperFg: 'colorFg',
  stepperCompletedIconSize: '1.5rem',
  stepperCompletedIconWeight: 'fontWeightUltraBold',
  stepperStepPadding: 'padding',
  accordionPadding: 'padding',
  accordionSeparator: 'separator',
  accordionHeaderFontFamily: 'fontSecondary',
  accordionHeaderFontSize: 'fontSizeLg',
  accordionHeaderFontWeight: 'fontWeightNormal',
  accordionHeaderFgHeading: 'colorFgHeading',
  accordionHeaderDisabledFg: 'colorFg',
  accordionHeaderBorderWidth: '1px',
  accordionHeaderBorderType: 'solid',
  accordionHeaderBorderColor: 'accordionSeparator',
  accordionBorderRadius: 'radius',
  accordionItemBg: 'colorBg',
  accordionItemFontSize: 'fontSize',
  accordionItemFontWeight: 'fontWeightNormal',
  accordionItemFontFamily: 'fontMain',
  accordionItemFgText: 'colorFgText',
  accordionItemShadow: 'shadow',
  listItemBorderColor: 'tabsSeparator',
  listItemPadding: '1rem',
  calendarWidth: '21.875rem',
  calendarBodyHeight: '25.625rem',
  calendarHeaderTitleFontSize: 'fontSizeXlg',
  calendarHeaderTitleFontWeight: 'fontWeightBold',
  calendarHeaderSubTitleFontSize: 'fontSize',
  calendarHeaderSubTitleFontWeight: 'fontWeightThin',
  calendarNavigationButtonWidth: '10rem',
  calendarSelectedItemBg: 'colorSuccess',
  calendarHoverItemBg: 'calendarSelectedItemBg',
  calendarTodayItemBg: 'colorBgActive',
  calendarActiveItemBg: 'colorSuccess',
  calendarFg: 'colorFgText',
  calendarSelectedFg: 'colorWhite',
  calendarTodayFg: 'calendarFg',
  calendarDayCellWidth: '2.625rem',
  calendarDayCellHeight: '2.625rem',
  calendarMonthCellWidth: '4.25rem',
  calendarMonthCellHeight: '2.375rem',
  calendarYearCellWidth: 'calendarMonthCellWidth',
  calendarYearCellHeight: 'calendarMonthCellHeight',
  calendarInactiveOpacity: 0.5,
  calendarDisabledOpacity: 0.3,
  calendarBorderRadius: 'radius',
  calendarWeekdayWidth: 'calendarDayCellWidth',
  calendarWeekdayHeight: '1.75rem',
  calendarWeekdayFontSize: 'fontSizeXs',
  calendarWeekdayFontWeight: 'fontWeightNormal',
  calendarWeekdayFg: 'colorFg',
  calendarWeekdayHolidayFg: 'colorDanger',
  calendarRangeBgInRange: '#ebfbf2',
  calendarLargeWidth: '24.375rem',
  calendarLargeBodyHeight: '27.75rem',
  calendarDayCellLargeWidth: '3rem',
  calendarDayCellLargeHeight: '3rem',
  calendarMonthCellLargeWidth: '4.25rem',
  calendarMonthCellLargeHeight: '2.375rem',
  calendarYearCellLargeWidth: 'calendarMonthCellWidth',
  calendarYearCellLargeHeight: 'calendarMonthCellHeight',
  overlayBackdropBg: 'rgba(0, 0, 0, 0.288)',
  tooltipBg: 'colorFgText',
  tooltipPrimaryBg: 'colorPrimary',
  tooltipInfoBg: 'colorInfo',
  tooltipSuccessBg: 'colorSuccess',
  tooltipWarningBg: 'colorWarning',
  tooltipDangerBg: 'colorDanger',
  tooltipFg: 'colorBgActive',
  tooltipStatusFg: 'colorBgActive',
  tooltipShadow: 'shadow',
  tooltipFontSize: 'fontSize',
  selectBorderWidth: '2px',
  selectMaxHeight: '20rem',
  selectBg: 'colorBg',
  selectCheckboxColor: 'checkboxBorderColor',
  selectCheckmarkColor: 'checkboxBorderColor',
  selectOptionDisabledBg: '#f2f4f7',
  selectOptionDisabledOpacity: 0.3,
  selectOptionPadding: '0.75rem 1.5rem',
  datepickerFg: 'colorFgHeading',
  datepickerBg: 'colorBg',
  datepickerBorder: 'colorSuccess',
  datepickerBorderRadius: 'radius',
  datepickerShadow: 'none',
  datepickerArrowSize: '11px',
  radioBg: 'transparent',
  radioFg: 'colorFgText',
  radioSize: '1.25rem',
  radioBorderSize: '2px',
  radioBorderColor: 'formControlBorderColor',
  radioCheckmark: 'transparent',
  radioCheckedBg: 'transparent',
  radioCheckedSize: '1.25rem',
  radioCheckedBorderSize: '2px',
  radioCheckedBorderColor: 'colorSuccess',
  radioCheckedCheckmark: 'colorSuccess',
  radioDisabledBg: 'transparent',
  radioDisabledSize: '1.25rem',
  radioDisabledBorderSize: '2px',
  radioDisabledBorderColor: 'radioBorderColor',
  radioDisabledCheckmark: 'radioCheckmark'
};

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n      @media (min-width: ", "px) and (max-width: ", "px) {\n        ", "\n      }\n    "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n      @media (min-width: ", "px) and (max-width: ", "px) {\n        ", "\n      }\n    "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n      @media (min-width: ", "px) {\n        ", "\n      }\n    "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n      @media (max-width: ", "px) {\n        ", "\n      }\n    "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var gridSize = 12;
var gridGutter = 24;
var breakpoints = {
  xs: 0,
  is: 400,
  sm: 576,
  md: 768,
  lg: 992,
  xl: 1200,
  xxl: 1400,
  xxxl: 1600
};
var maxContainer = {
  is: 380,
  sm: 540,
  md: 720,
  lg: 960,
  xl: 1140,
  xxl: 1320,
  xxxl: 1500
};

function getGridSize(theme) {
  return theme.gridSize ? theme.gridSize : gridSize;
}

function getGridGutter(theme) {
  return theme.gridGutter ? theme.gridGutter : gridGutter;
}

function ifWidthInBreakpoint() {
  var breakpoint = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var bp = Object.keys(breakpoints);
  var value = false;

  if (breakpoint === []) {
    return value;
  }

  breakpoint.filter(function (b) {
    return ~bp.indexOf(b);
  }).sort(function (b1, b2) {
    return bp.indexOf(b1) - bp.indexOf(b2);
  }).forEach(function (b) {
    var next = breakpointNext(bp.indexOf(b));

    if (window.innerWidth >= breakpoints[b] && (next == null || window.innerWidth < breakpoints[next])) {
      value = true;
    }
  });
  return value;
}

function breakpointMin(name) {
  return breakpoints[name] !== 0 ? breakpoints[name] : null;
}

function breakpointNext(index) {
  return index < Object.keys(breakpoints).length ? Object.keys(breakpoints)[index + 1] : null;
}

function breakpointMax(name) {
  var n = Object.keys(breakpoints).indexOf(name);
  var next = breakpointNext(n);
  return next ? breakpointMin(next) - 0.2 : null;
}

var breakpointDown = function breakpointDown(name) {
  return function () {
    var max = breakpointMax(name);

    if (max) {
      return styledComponents.css(_templateObject(), max, styledComponents.css.apply(void 0, arguments));
    } else {
      return styledComponents.css.apply(void 0, arguments);
    }
  };
};

var breakpointUp = function breakpointUp(name) {
  return function () {
    var min = breakpointMin(name);

    if (min) {
      return styledComponents.css(_templateObject2(), min, styledComponents.css.apply(void 0, arguments));
    } else {
      return styledComponents.css.apply(void 0, arguments);
    }
  };
};

var breakpointBetween = function breakpointBetween(lower, upper) {
  return function () {
    var min = breakpointMin(lower);
    var max = breakpointMax(upper);

    if (min != null && max != null) {
      return styledComponents.css(_templateObject3(), min, max, styledComponents.css.apply(void 0, arguments));
    } else if (max == null) {
      return breakpointUp(lower).apply(void 0, arguments);
    } else if (min == null) {
      return breakpointDown(upper).apply(void 0, arguments);
    }
  };
};

var breakpointOnly = function breakpointOnly(name) {
  return function () {
    var min = breakpointMin(name);
    var max = breakpointMax(name);

    if (min != null && max != null) {
      return styledComponents.css(_templateObject4(), min, max, styledComponents.css.apply(void 0, arguments));
    } else if (max == null) {
      return breakpointUp(name).apply(void 0, arguments);
    } else if (min == null) {
      return breakpointDown(name).apply(void 0, arguments);
    }
  };
};

var themeValues = {
  "default": defaultTheme,
  cosmic: cosmicTheme,
  corporate: corporateTheme
};
function themes(theme) {
  var settings = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  switch (theme) {
    case 'cosmic':
    case 'corporate':
      return getThemeValue(_objectSpread2({}, defaultTheme, {}, themeValues[theme], {}, settings, {
        theme: theme
      }));

    default:
      return getThemeValue(_objectSpread2({}, defaultTheme, {}, settings, {
        theme: theme
      }));
  }
}

function getThemeValue(settings) {
  Object.keys(settings).forEach(function (key) {
    settings[key] = getKeyValue(settings, key);
  });
  return settings;
}

function getKeyValue(settings, key) {
  if (settings[settings[key]]) {
    return getKeyValue(settings, settings[key]);
  } else {
    return settings[key];
  }
}

exports.breakpointBetween = breakpointBetween;
exports.breakpointDown = breakpointDown;
exports.breakpointOnly = breakpointOnly;
exports.breakpointUp = breakpointUp;
exports.breakpoints = breakpoints;
exports.getGridGutter = getGridGutter;
exports.getGridSize = getGridSize;
exports.ifWidthInBreakpoint = ifWidthInBreakpoint;
exports.maxContainer = maxContainer;
exports.themes = themes;
